#!/usr/bin/env python

class bitxormatrix:
	"""	stores two integers and the XOR matrix of every bit with every
		other bit of the two integers.  pre-calculating these saves time,
		when there are several billion bit-compares to perform...
	"""

	def __init__(self, k, d, k_len, d_len):

		self.k = k
		self.d = d

		self.pre_rotate(k_len, d_len)

	def _slow_test_bit_eq(self, kb, db):
		return (self.k & (1<<kb) != 0) ^ (self.d & (1<<db) != 0)

	def bit_eq(self, kb, db):
		return self.kd[db] & (1<<kb) != 0

	def pre_rotate(self, k_len, d_len):
		"""	assume data length (in bits) is the longer.
		"""

		self.kd = {}
		ko = 0
		for i in range(k_len):
			ko |= 1<<i
		for dl in range(d_len):
			if self.d & (1<<dl):
				self.kd[dl] = self.k ^ ko
			else:
				self.kd[dl] = self.k

def test():

	k = 0xeaL
	d = 0x1a2bL
	t = bitxormatrix(k, d, 8, 16)

	for i in range(8):
		for j in range(16):
			assert t.bit_eq(i, j) == t._slow_test_bit_eq(i, j)

if __name__ == '__main__':
	test()
